-- Copyright (c) 2012 Cloudera, Inc. All rights reserved.
--
-- Version 4518 of the CMF schema.
-- Add host templates.
--

update SCHEMA_VERSION set VERSION=4518;

create table HOST_TEMPLATES (
  HOST_TEMPLATE_ID int8 not null,
  OPTIMISTIC_LOCK_VERSION int8 not null,
  NAME varchar(255) not null unique,
  CLUSTER_ID int8 not null,
  primary key (HOST_TEMPLATE_ID)
);

alter table HOST_TEMPLATES
  add constraint FK_HOST_TEMPLATE_CLUSTER
  foreign key (CLUSTER_ID)
  references CLUSTERS (CLUSTER_ID);

create index IDX_HOST_TEMPLATE_CLUSTER on HOST_TEMPLATES (CLUSTER_ID);

create table HOST_TEMPLATE_TO_ROLE_CONF_GRP (
  HOST_TEMPLATE_ID int8 not null,
  ROLE_CONFIG_GROUP_ID int8 not null,
  primary key (HOST_TEMPLATE_ID, ROLE_CONFIG_GROUP_ID)
);

alter table HOST_TEMPLATE_TO_ROLE_CONF_GRP
  add constraint FK_HOST_TEMPL_TO_RCG_HOST_TEMP
  foreign key (HOST_TEMPLATE_ID)
  references HOST_TEMPLATES (HOST_TEMPLATE_ID);

alter table HOST_TEMPLATE_TO_ROLE_CONF_GRP
  add constraint FK_HOST_TEMPL_TO_RCG_RCG
  foreign key (ROLE_CONFIG_GROUP_ID)
  references ROLE_CONFIG_GROUPS (ROLE_CONFIG_GROUP_ID);

create index IDX_HOST_TEMPL_TO_RCG_HOST_TMP on HOST_TEMPLATE_TO_ROLE_CONF_GRP (HOST_TEMPLATE_ID);
create index IDX_HOST_TEMPL_TO_RCG_RCG on HOST_TEMPLATE_TO_ROLE_CONF_GRP (ROLE_CONFIG_GROUP_ID);
